# IRremoteESP8266: IRDaikin160 Class Reference

IRDaikin160 Class Reference

Class for handling detailed Daikin 160-bit A/C messages. More...

`#include <ir_Daikin.h>`

Collaboration diagram for IRDaikin160:
[legend]

## Public Member Functions

| IRDaikin160 (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
void | send (const uint16_t repeat=kDaikin160DefaultRepeat)
| Send the current internal state as an IR message. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | begin (void)
| Set up hardware to be able to send a message. More...
uint8_t * | getRaw (void)
| Get a PTR to the internal state/code for this protocol. More...
void | setRaw (const uint8_t new_code[])
| Set the internal state from a valid code for this protocol. More...
void | on (void)
| Change the power setting to On. More...
void | off (void)
| Change the power setting to Off. More...
void | setPower (const bool on)
| Change the power setting. More...
bool | getPower (void) const
| Get the value of the current power setting. More...
void | setTemp (const uint8_t temp)
| Set the temperature. More...
uint8_t | getTemp (void) const
| Get the current temperature setting. More...
void | setMode (const uint8_t mode)
| Set the operating mode of the A/C. More...
uint8_t | getMode (void) const
| Get the operating mode setting of the A/C. More...
void | setFan (const uint8_t fan)
| Set the speed of the fan. More...
uint8_t | getFan (void) const
| Get the current fan speed setting. More...
void | setSwingVertical (const uint8_t position)
| Set the Vertical Swing mode of the A/C. More...
uint8_t | getSwingVertical (void) const
| Get the Vertical Swing mode of the A/C. More...
stdAc::state_t | toCommon (void) const
| Convert the current internal state into its stdAc::state_t equivalent. More...
String | toString (void) const
| Convert the current internal state into a human readable string. More...

## Static Public Member Functions

static bool | validChecksum (uint8_t state[], const uint16_t length=kDaikin160StateLength)
| Verify the checksum is valid for a given state. More...
static uint8_t | convertMode (const stdAc::opmode_t mode)
| Convert a stdAc::opmode_t enum into its native mode. More...
static uint8_t | convertFan (const stdAc::fanspeed_t speed)
| Convert a stdAc::fanspeed_t enum into it's native speed. More...
static uint8_t | convertSwingV (const stdAc::swingv_t position)
| Convert a stdAc::swingv_t enum into it's native setting. More...
static stdAc::swingv_t | toCommonSwingV (const uint8_t setting)
| Convert a native vertical swing postion to it's common equivalent. More...

## Private Member Functions

void | stateReset (void)
| Reset the internal state to a fixed known good state. More...
void | checksum (void)
| Calculate and set the checksum values for the internal state. More...

## Private Attributes

IRsend | _irsend
| instance of the IR send class More...
Daikin160Protocol | _

## Detailed Description

Class for handling detailed Daikin 160-bit A/C messages.

## Constructor & Destructor Documentation

## IRDaikin160()

IRDaikin160::IRDaikin160 | ( | const uint16_t | pin,
|  | const bool | inverted = `false`,
|  | const bool | use_modulation = `true`
| ) |  |

explicit

Class constructor.

Parameters

  [in] | pin | GPIO to be used when sending.
  [in] | inverted | Is the output signal to be inverted?
  [in] | use_modulation | Is frequency modulation to be used?

## Member Function Documentation

## begin()

void IRDaikin160::begin | ( | void |  | ) |

Set up hardware to be able to send a message.

## calibrate()

int8_t IRDaikin160::calibrate | ( | void |  | ) |

inline

Run the calibration to calculate uSec timing offsets for this platform.

Returns
  The uSec timing offset needed per modulation of the IR Led.

Note
  This will produce a 65ms IR signal pulse at 38kHz. Only ever needs to be run once per object instantiation, if at all.

## checksum()

void IRDaikin160::checksum | ( | void |  | ) |

private

Calculate and set the checksum values for the internal state.

## convertFan()

uint8_t IRDaikin160::convertFan | ( | const stdAc::fanspeed_t | speed | ) |

static

Convert a stdAc::fanspeed_t enum into it's native speed.

Parameters

  [in] | speed | The enum to be converted.

Returns
  The native equivalent of the enum.

## convertMode()

uint8_t IRDaikin160::convertMode | ( | const stdAc::opmode_t | mode | ) |

static

Convert a stdAc::opmode_t enum into its native mode.

Parameters

  [in] | mode | The enum to be converted.

Returns
  The native equivalent of the enum.

## convertSwingV()

uint8_t IRDaikin160::convertSwingV | ( | const stdAc::swingv_t | position | ) |

static

Convert a stdAc::swingv_t enum into it's native setting.

Parameters

  [in] | position | The enum to be converted.

Returns
  The native equivalent of the enum.

## getFan()

uint8_t IRDaikin160::getFan | ( | void |  | ) | const

Get the current fan speed setting.

Returns
  The current fan speed.

## getMode()

uint8_t IRDaikin160::getMode | ( | void |  | ) | const

Get the operating mode setting of the A/C.

Returns
  The current operating mode setting.

## getPower()

bool IRDaikin160::getPower | ( | void |  | ) | const

Get the value of the current power setting.

Returns
  true, the setting is on. false, the setting is off.

## getRaw()

uint8_t * IRDaikin160::getRaw | ( | void |  | ) |

Get a PTR to the internal state/code for this protocol.

Returns
  PTR to a code for this protocol based on the current internal state.

## getSwingVertical()

uint8_t IRDaikin160::getSwingVertical | ( | void |  | ) | const

Get the Vertical Swing mode of the A/C.

Returns
  The native position/mode setting.

## getTemp()

uint8_t IRDaikin160::getTemp | ( | void |  | ) | const

Get the current temperature setting.

Returns
  The current setting for temp. in degrees celsius.

## off()

void IRDaikin160::off | ( | void |  | ) |

Change the power setting to Off.

## on()

void IRDaikin160::on | ( | void |  | ) |

Change the power setting to On.

## send()

void IRDaikin160::send | ( | const uint16_t | repeat = `kDaikin160DefaultRepeat` | ) |

Send the current internal state as an IR message.

Parameters

  [in] | repeat | Nr. of times the message will be repeated.

## setFan()

void IRDaikin160::setFan | ( | const uint8_t | fan | ) |

Set the speed of the fan.

Parameters

  [in] | fan | The desired setting.

Note
  1-5 or kDaikinFanAuto or kDaikinFanQuiet

## setMode()

void IRDaikin160::setMode | ( | const uint8_t | mode | ) |

Set the operating mode of the A/C.

Parameters

  [in] | mode | The desired operating mode.

## setPower()

void IRDaikin160::setPower | ( | const bool | on | ) |

Change the power setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## setRaw()

void IRDaikin160::setRaw | ( | const uint8_t | new_code[] | ) |

Set the internal state from a valid code for this protocol.

Parameters

  [in] | new_code | A valid code for this protocol.

## setSwingVertical()

void IRDaikin160::setSwingVertical | ( | const uint8_t | position | ) |

Set the Vertical Swing mode of the A/C.

Parameters

  [in] | position | The position/mode to set the swing to.

## setTemp()

void IRDaikin160::setTemp | ( | const uint8_t | temp | ) |

Set the temperature.

Parameters

  [in] | temp | The temperature in degrees celsius.

## stateReset()

void IRDaikin160::stateReset | ( | void |  | ) |

private

Reset the internal state to a fixed known good state.

## toCommon()

stdAc::state_t IRDaikin160::toCommon | ( | void |  | ) | const

Convert the current internal state into its stdAc::state_t equivalent.

Returns
  The stdAc equivalent of the native settings.

## toCommonSwingV()

stdAc::swingv_t IRDaikin160::toCommonSwingV | ( | const uint8_t | setting | ) |

static

Convert a native vertical swing postion to it's common equivalent.

Parameters

  [in] | setting | A native position to convert.

Returns
  The common vertical swing position.

## toString()

String IRDaikin160::toString | ( | void |  | ) | const

Convert the current internal state into a human readable string.

Returns
  A human readable string.

## validChecksum()

bool IRDaikin160::validChecksum | ( | uint8_t | state[],
|  | const uint16_t | length = `kDaikin160StateLength`
| ) |  |

static

Verify the checksum is valid for a given state.

Parameters

  [in] | state | The array to verify the checksum of.
  [in] | length | The length of the state array.

Returns
  true, if the state has a valid checksum. Otherwise, false.

## Member Data Documentation

## _

Daikin160Protocol IRDaikin160::_

private

## _irsend

IRsend IRDaikin160::_irsend

private

instance of the IR send class

The documentation for this class was generated from the following files:

- src/ir_Daikin.h
- src/ir_Daikin.cpp